#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <stdio.h>

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"


void
on_roll_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *results = lookup_widget( GTK_WIDGET(button), "results");

  GtkWidget *dice = lookup_widget( GTK_WIDGET(button), "dice_count");
  GtkWidget *target = lookup_widget( GTK_WIDGET(button), "target_number");

  GtkWidget *double10_button = lookup_widget( GTK_WIDGET(button), "double10");
  GtkWidget *reroll10_button = lookup_widget( GTK_WIDGET(button), "reroll10");
  //  GtkWidget *ignore10_button = lookup_widget( GTK_WIDGET(button), "ignore10");

  GtkWidget *subtract1_button = lookup_widget( GTK_WIDGET(button), "subtract1");
  //  GtkWidget *ignore1_button = lookup_widget( GTK_WIDGET(button), "ignore1");

  int dice_count = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON (dice));
  int target_number = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON (target));

  gboolean double10 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (double10_button));
  gboolean reroll10 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (reroll10_button));
  //  gboolean ignore10 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (ignore10_button));

  gboolean subtract1 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (subtract1_button));
  //  gboolean ignore1 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (ignore1_button));


  int successes = 0;
  gboolean one_has_been_rolled = 0;

  gchar *labels[1]; /* Yes, a constant, because there's only one
		       column in the CList right now */

  int die=2; /* changes in the while loop, holding one die's value at
	        a time. set to a nice comfortable non-botch
	        non-success value by default, just in case we're asked
	        to roll negative dice. */

  while (dice_count > 0) {
    die = 1+(int) (10.0*rand()/(RAND_MAX+1.0));
    if (die >= target_number) {
      successes += 1;
    }
    if (1 == die) {
      one_has_been_rolled = TRUE;
      if (subtract1) {
	successes -= 1;
      }
    }
    if (10 == die) {
      if (double10) {
	successes += 1;
      } else if (reroll10) {
	dice_count += 1;
      }
    }
    dice_count -= 1;
  }

  labels[0] = malloc(sizeof(gchar[21]));

  if ((one_has_been_rolled) && (successes < 1)) {
    //    labels[0] = "Botch";
    snprintf(labels[0], 20, "Botch: %i", successes);
  } else if (0 >= successes) {
    //    labels[0] = "Failure";
    snprintf(labels[0], 20, "Failure: %i", successes);
  } else {
    //    labels[0] = "Success";
    snprintf(labels[0], 20, "Success: %i", successes);
  }

  gtk_clist_append( GTK_CLIST (results), labels);
			       
} /* end of on_roll_clicked */


void
on_clear_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{

    GtkWidget *results = lookup_widget( GTK_WIDGET(button), "results");

    gtk_clist_clear ( GTK_CLIST (results));

}


void
on_window1_show                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
  srand( (unsigned) time(NULL));
}

